import type { Player, Token } from "@prisma/client"
import { rejectionErrors } from "../errors"
import prisma from "../../prisma"
import sendError, { API } from "./sendError"

export default async function getPlayerByIdDB(
  context: API,
  tokenDB: Token,
  next: (player: Player) => void
) {
  // Find Host in DB if it still exists (just to make sure)
  const player = await prisma.player.findUnique({
    where: {
      id: tokenDB.ownerId,
    },
  })
  if (!player) {
    return sendError(context, rejectionErrors.playerNotFound)
  }

  return next(player)
}
