import type { RawToken } from "./createTokenDB"
import sendError, { API } from "./sendError"
import { rejectionErrorFns } from "../errors"

async function getTokenFromBody(
  context: API,
  next: (accessToken: RawToken) => void
) {
  const type = "ACCESS"
  const body = JSON.parse(context.req.body)
  // Checking for cookie presens, because it is necessary
  if (
    typeof body === "object" &&
    body &&
    "token" in body &&
    typeof body.token === "string"
  ) {
    const value = body.token
    return next({ value, type })
  }

  return sendError(context, rejectionErrorFns.noToken(type))
}

export default getTokenFromBody
