import createPlayerDB from "./createPlayerDB"
import createTokenDB, { RawToken } from "./createTokenDB"
import type { API } from "./sendError"

async function getTokenFromCookie(
  context: API,
  next: (refreshToken: RawToken) => void
) {
  const type = "REFRESH"
  const value = context.req.cookies.token

  // Checking for cookie presens, because it is necessary
  if (!value) {
    return createPlayerDB((player) =>
      createTokenDB(player, type, (newToken) => next(newToken))
    )
  }
  return next({ value, type })
}

export default getTokenFromCookie
